<%
'*********************************************************************************
' 7.00
' 1 Dec 2009
' Customer based pricing
' after a price has been read from the Database
' This routine is called by GetProduct to determine whether
' there is a specific price for  acustomer
'*********************************************************************************

const customerpricetable="customerprices"

'obtain the correct price for the customer
'first lookup specific product
'if not found lookup specific category
sub shopcustomerprices (objrs, CatalogId, categoryid, ioprice, newprice,discount)
   dim customerid, rc, discountpercent,contactid,propricegroup
   if GetConfig("xcustomerPrices")<>"Yes" then exit sub
   'check customer groups
   contactid = getsess("CustomerID")
   discountpercent = getgroupdiscount(contactid)
   propricegroup = getgrouppropricefield(contactid)
   if trim(contactid) <> "" then
      if discountpercent > 0 or trim(propricegroup) <> "" then
	     CustomerPricesinRecord objrs,ioprice,newprice,discount,discountpercent,propricegroup
		 '700 - 2010.05.03 - Customer Group Pricing not updated if group price field is set, but group discount field is not set.
		 if trim(propricegroup) <> "" then
		    exit sub
		 else
		    if discount > 0 then exit sub
		 end if
      end if
   end if
   discount=0
   newprice=ioprice
   customerid=GetSess("Customerid")
   if customerid="" or isnull(customerid) then
      exit sub
   end if
   LookupCustomerProduct CatalogId, customerid, newprice,discount, rc
   if rc= 0 then
      exit sub
   end if
   LookupCustomerCategory categoryid, customerid, NewPrice,discount, rc
   if rc=0 then
      exit sub
   end if
   LookupCustomerOnly customerid, NewPrice,discount, rc
   if rc=0 then
      exit sub
   end if
end sub

sub LookupCustomerProduct (CatalogId, customerid, Price,discount, rc)
dim lookupsql, lookuprs, oldprice, newprice
dim Discountamount,DiscountPercent
lookupsql="select * from " & customerpricetable
lookupsql = lookupsql & " where customerid=" & customerid
lookupsql = lookupsql & " and CatalogId=" & CatalogId
Set lookuprs = Server.CreateObject("ADODB.Recordset")
'700 - 2010.09.26 - Enhancement: Speed up front store performance
lookuprs.open lookupsql, dbc, adOpenStatic, adLockOptimistic
if lookuprs.eof then
   rc=4
   lookuprs.close
   set lookuprs=nothing
   exit sub
end if
discountamount=lookuprs("discountamount")
discountpercent=lookuprs("discountpercent")
ApplyCustomerprice Price, discountamount, discountPercent, discount
lookuprs.close
set lookuprs=nothing
end sub

sub ApplyCustomerprice (price, amount, percent, discount)
dim newprice
if not isnull(amount) and amount>0 then
   Newprice=price-amount
   discount=newprice/price
   discount=1-discount
   discount=discount*100
   price=newprice
   exit sub
end if
if not isnull(percent) then
   discount=percent
   if percent>1 then
      percent=percent/100
   end if
   Newprice=price- (Price*percent)
   NewPrice=formatnumber(NewPrice,GetConfig("xdecimalpoint"))
   price=Newprice
end if
end sub

sub LookupCustomerCategory (categoryid, customerid, Price,discount, rc)
dim Discountamount,DiscountPercent
dim lookupsql, lookuprs, discountper, newprice
lookupsql="select * from " & customerpricetable
lookupsql = lookupsql & " where customerid=" & customerid
lookupsql = lookupsql & " and categoryid=" & categoryid
Set lookuprs = Server.CreateObject("ADODB.Recordset")
'700 - 2010.09.26 - Enhancement: Speed up front store performance
lookuprs.open lookupsql, dbc, adOpenStatic, adLockOptimistic
if lookuprs.eof then
   rc=4
   lookuprs.close
   set lookuprs=nothing
   exit sub
end if
Discountamount=lookuprs("Discountamount")
DiscountPercent=lookuprs("Discountpercent")
if GetConfig("xdebug")="Yes" then
   DebugWrite "Price=" & price &  " discountPercent=" & discountpercent
end if
ApplyCustomerprice Price, discountamount, discountPercent, discount
lookuprs.close
set lookuprs=nothing
rc=0
end sub

sub LookupCustomerOnly (customerid, Price,discount, rc)
dim Discountamount,DiscountPercent
dim lookupsql, lookuprs, discountper, newprice
lookupsql="select * from " & customerpricetable
lookupsql = lookupsql & " where customerid=" & customerid
lookupsql = lookupsql & " and categoryid=0 and CatalogId=0"
Set lookuprs = Server.CreateObject("ADODB.Recordset")
'700 - 2010.09.26 - Enhancement: Speed up front store performance
lookuprs.open lookupsql, dbc, adOpenStatic, adLockOptimistic
if lookuprs.eof then
   rc=4
   lookuprs.close
   set lookuprs=nothing
   exit sub
end if
Discountamount=lookuprs("Discountamount")
DiscountPercent=lookuprs("Discountpercent")
if GetConfig("xdebug")="Yes" then
   DebugWrite "Price=" & price &  " discountPercent=" & discountpercent
end if
ApplyCustomerprice Price, discountamount, discountPercent, discount
lookuprs.close
set lookuprs=nothing
rc=0
end sub


'contact id field determines which customer price field to use
'objrs is the current record in products table
'Uses xcustomerpricefields
'xcustomepricesindexes
'*****************************************************************
sub  CustomerPricesinRecord (objrs,oldprice,newprice,discount,discountpercent,propricegroup)
   dim fields(50),fieldcount, customerpricefields, customerpricetypes
   dim types(50), typecount, customertype, ctype, pricefield
   dim donumerictest, i, xdebug
   dim customerpricepercents    ' specific discount percentage per group
   dim usediscountgroup
   on error goto 0
   xdebug=GetConfig("xdebug")
   usediscountgroup=false
   customerpricefields=propricegroup
   customerpricepercents=discountpercent
   if customerpricefields="" then
      if customerpricepercents<>"" then
         usediscountgroup=true
      else
         exit sub
      end if
   end if

   pricefield=customerpricefields
   if usediscountgroup=false then
      SetCustomerPriceField objrs, pricefield, oldprice,newprice, i,discount,customerpricepercents,"PF"
   else
      SetCustomerDiscountGroup oldprice,newprice,i,discount,customerpricepercents,"GD"
   end if
end sub

sub SetCustomerPriceField (objrs, fieldname, oldprice, newprice, i,discount,discountpercent,fromwhere)
   dim tprice
   '700 - 2010.05.03 - Customer Group Pricing not updated if group price field is set, but group discount field is not set.
   on error resume next
   tprice=objrs(fieldname)
   if err.number <> 0 then
      err.clear
	  tprice = getproductcustomerfield(objrs("catalogid"),fieldname)
   end if
   if isnull(tprice) or trim(tprice) = "" then
      SetCustomerDiscountGroup oldprice,newprice,i,discount,discountpercent,"GD"
   else
      newprice = tprice
      SetCustomerDiscountGroup oldprice,newprice, i,discount,discountpercent,fromwhere
   end if
end sub

'Using xcustomerpricepercents
'to apply a discount
'could be used when no customerprice fields are if price field is null
'If percent is greater tahn 1, customer prive can be greater than original price
sub SetCustomerDiscountGroup (oldprice,newprice, i, discount, discountpercent,fromwhere)
   dim customerpricepercents, percents(50), percentcount
   dim percent
   'dim oldprice
   'dim discount
   customerpricepercents=discountpercent
   if customerpricepercents="" then exit sub
   percent=customerpricepercents
   if percent="" then exit sub
   if not isnumeric(percent) then exit sub

   if trim(fromwhere) = "GD" then
      if percent<1 then
         discount=oldprice*csng(percent)
      else
	     discount=percent
      end if
	  newprice=oldprice-discount
   else
      if percent<1 then
         discount=newprice*csng(percent)
      else
	     discount=percent
      end if
	  newprice=newprice-discount
   end if
end sub

'700 - 2010.05.03 - Customer Group Pricing not updated if group price field is set, but group discount field is not set.
'get custom product field
function getproductcustomerfield(catalogid,fieldname)
   if trim(catalogid) = "" then
      getproductcustomerfield = ""
      exit function
   end if
   if trim(fieldname) = "" then
      getproductcustomerfield = ""
      exit function
   end if

   dim sqlrs,strsql,tempvalue
   strsql="select "& fieldname &" from products where catalogid = "& catalogid &""
   Set sqlrs = Server.CreateObject("ADODB.Recordset")
   '700 - 2010.09.26 - Enhancement: Speed up front store performance
   '701 - 2011.03.15 - Enhancement: Speed up store performance
   sqlrs.open strsql, dbc, adOpenForwardOnly, adLockReadOnly
   if not sqlrs.eof then
      tempvalue = sqlrs(fieldname)
   end if
   closerecordset sqlrs
   getproductcustomerfield = tempvalue
end function
%>